#include "arg.h"
#include "log.h"
#include "dep.h"
#include "generator.h"

/* Runs when a custom command line argument is found
 returns true if no furhter argument processing should be done */
int hook_custom_arg(const char *key, const char *value)
{
	return 0;
}


/* Runs before anything else */
int hook_preinit()
{
	return 0;
}

/* Runs after initialization */
int hook_postinit()
{
	report("=== configuring equver ===\n");
	return 0;
}

/* Runs after all arguments are read and parsed */
int hook_postarg()
{
	return 0;
}

/* Runs when things should be detected for the host system */
int hook_detect_host()
{
	logprintf(0, "==== hook_detect_host() ===\n");
	/* we run bison and flex on host */
	require("parsgen/flex", 1, 1);
	require("parsgen/bison", 1, 1);
	return 0;
}

/* Runs when things should be detected for the target system */
int hook_detect_target()
{
	logprintf(0, "==== hook_detect_target() ===\n");
	require("cc/cc", 1, 1);
	require("sys/ext_exe", 1, 1);
	require("libs/math/minpack/ldflags", 1, 1);
	return 0;
}

/* Runs after detection hooks, should generate the output (Makefiles, etc.) */
int hook_generate()
{
	generate("../src/Makefile.in", "../src/Makefile");
	return 0;
}

/* Runs before everything is uninitialized */
void hook_preuninit()
{
}

/* Runs at the very end, when everything is already uninitialized */
void hook_postuninit()
{
}

